<?php

/**
 * cgmv_inf_obligaciones actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage cgmv_inf_obligaciones
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cgmv_inf_obligacionesActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' Order by fecha_radicado, radicado';
        }
        $sortBy = ' ';

        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $fecha_ini_text = $fecha_ini;
            $fecha_fin_text = $fecha_fin;


            /*
             * Variables opcionales
             */
            //id_contratista
            if (isset($request['id_contratista'])) {
                $whereIdContratista = " AND tab0.id_contratista = " . $request['id_contratista'];
            } else {
                $whereIdContratista = ' ';
            }
            //id_contrato
            if (isset($request['id_contrato'])) {
                $whereIdContrato = " AND tab0.id_contrato = " . $request['id_contrato'];
            } else {
                $whereIdContrato = ' ';
            }
            //id_numero_pago
            if (isset($request['id_numero_pago'])) {
                $whereIdNumeroPago = " AND tab0.id_numero_pago = " . $request['id_numero_pago'];
            } else {
                $whereIdNumeroPago = ' ';
            }
            //usuario_asignado
            if (isset($request['usuario_asignado'])) {
                $whereUsuarioAsignado = " AND tab0.usuario_asignado = '" . $request['usuario_asignado'] . "'";
            } else {
                $whereUsuarioAsignado = ' ';
            }
            //Recurso: 0-ANM 1-SGR
            $recurso = '';
            if (isset($request['recurso'])) {
                if ($request['recurso'] == 1) {
                    $recurso = ' SGR';
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 1 ";
                } elseif ($request['recurso'] == 0 && $request['recurso'] != 'false') {
                    $recurso = ' PGN';
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 0 ";
                } else {
                    $whereTipoRecurso = " ";
                }
            } else {
                $whereTipoRecurso = "";
            }

            $filtro_clase_presup = "";
            if (isset($request['clasepresup'])) {
                if ($request['clasepresup'] == 8) {
                    $clasepresup = 8;
                } elseif ($request['clasepresup'] == 9) {
                    $clasepresup = 9;
                } else {
                    $clasepresup = 0;
                }

                if ($clasepresup != 0) {
                    /**
                     * Filtro por clase presupuestal 8-funcionamiento o 9-inversion - 20220405::LAVILA
                     */
                    $filtro_clase_presup = <<<EOD
and tab0.id_formato_pago in (

    select
    forrp.id_formato_pago
    
    from rvc_formato_proy_rp forrp
    
    join rvc_formato_pago forpag
    on forrp.id_formato_pago = forpag.id_formato_pago
    
    left join pr_rubro_pgnsgr_v rub
    on rub.id_rubro = forrp.id_rubro
    and rub.sgr = forrp.is_rp_sgr
    
    where
    rub.id_clase_presup = $clasepresup                            
    and forrp.valor != 0
    and forpag.estado = 1
    and forpag.cargasiif = 1
    and trunc(forpag.fecha_radicado) between to_date('$fecha_ini_text','yyyy-mm-dd') and to_date('$fecha_fin_text','yyyy-mm-dd')

)
EOD;
                }
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Consulta de pagos por fecha y estado aprobado
             * Recurso: 0-ANM 1-SGR
             * Cambiar  "Fecha Inicio de Pago"-"Fecha Aprobación Financiera:    - 20180822
             * Filtrar ahora estado CargaSIIF y no el Asignado - 20220405
             *  Incidente #32229, estructura del concepto - 20221011::LAVILA
             */
            $consulta_sql = <<<EOD
select
rownum as consecutivo,
trunc(sysdate) as fecha,
case when tipo_recurso = 0 then dat.CODIGO_SIIF else dat.CODIGO_SPGR end as PCIConexion,
tab0.id_rp_proyrp as rp,      
trunc(sysdate) as fecha_pago,
'NO' as moneda,
case when tipo_recurso = 0
      then case when tab0.declarante_renta = 1 then '31' else '64' end
      else case when tab0.declarante_renta = 1 then '053' else '054' end end as TipoCuentaPorPagar,
0 as valor_iva,
11 as tipo_doc_sop,
'RVC-' || tab0.numero_radicado as no_radicado,
tab0.fecha_radicado as fecha_radicado,
11 as expedidor,
upper(tab0.razon_soc_sup) as supervisor,
'SUPERVISOR' as cargo,
--'RVC '|| tab0.numero_radicado ||' CTO '|| tab0.num_contrato ||' '|| upper(tab0.pago_text) ||' PAGO - PERIODO '|| trim(upper(to_char(tab0.FECHA_INI_PAGO,'MONTH','nls_date_language=spanish'))) ||'/'|| to_char(tab0.FECHA_INI_PAGO,'yy') ||' '|| ' - RP '|| tab0.id_rp_proyrp as texto,
'RVC '|| tab0.numero_radicado ||' CTO'|| tab0.num_contrato ||' P'|| tab0.id_numero_pago ||' P'|| to_char(tab0.FECHA_INI_PAGO,'MON')|| to_char(tab0.FECHA_INI_PAGO,'YY') || ' - RP '|| tab0.id_rp_proyrp  || ' ASIG. ' || upper(tab0.RAZON_SOC_USU_ASIGNA) as texto,
   
tab0.id_formato_pago,
tab0.id_anhos,
tab0.id_numero_pago,
tab0.num_contrato                    

from(

    select
    proyrp.is_rp_sgr as tipo_recurso,
    proyrp.id_rp as id_rp_proyrp,
    proyrp.vigencia_rp,
    proyrp.is_rp_sgr,
    
    contra.declarante_renta,
    cont.razon_soc_sup,
    contra.profesion,
    cont.num_contrato,
    nump.descripcion as pago_text,
    
    forpag.*
    
    from rvc_formato_pago_v forpag
    
    left join rvc_contrato_v cont
    on forpag.id_contrato = cont.id_contrato
    
    left join rvc_contratista_v contra
    on forpag.id_contratista = contra.id_contratista
    
    left join ts_tc tc
    on tc.id = contra.tipo_cuenta
    
    left join rvc_numero_pago nump
    on nump.id_numero_pago = forpag.id_numero_pago
    
    left join(
    
        select
        id_formato_pago,
        id_rp,
        vigencia_rp,
        is_rp_sgr,
        sum(valor) as valor
        from
        rvc_formato_proy_rp
        where
        valor != 0
        group by
        id_formato_pago,
        id_rp,
        vigencia_rp,
        is_rp_sgr
    
    )proyrp
    on proyrp.id_formato_pago = forpag.id_formato_pago
    
    where
    forpag.estado = 1
    and forpag.estado_general = 10
    and trunc(forpag.fecha_radicado) between to_date('$fecha_ini_text','yyyy-mm-dd') and to_date('$fecha_fin_text','yyyy-mm-dd')
    
    order by
    forpag.fecha_radicado,
    forpag.radicado

)tab0

left join datos_compania dat
on dat.id = 1

where
1 = 1
$whereIdContratista
$whereIdContrato
$whereIdNumeroPago
$whereTipoRecurso
$whereUsuarioAsignado 
$filtro_clase_presup                    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[cgmv_inf_obligaciones] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
